openapi: 3.0.0
info:
  title: APIs Open Data do Open Insurance Brasil
  description:
    API de informações de dados do produto Empresarial. Os recursos que podem ser consumidos pelos participantes conforme a regra 3.1.2 do manual de escopo de dados..
  version: 1.1.0
  contact:
    url: 'https://www.gov.br/susep/'
servers:
  - url: 'https://api.organizacao.com.br/open-insurance/products-services/v1'
    description: Servidor de Producao
  - url: 'https://api.organizacao.com.br/open-insurance/products-services/v1'
    description: Servidor de Homologacao
tags:
  - name: "Empresarial"
  - name: "Business"

paths:
  /business:
    get:
      tags:
        - Business
      summary: Obtem a lista dos produtos do tipo Business
      description: "Obtem a lista dos produtos do tipo Business"
      operationId: "getBusiness"
      parameters:
        - $ref: "#/components/parameters/cache-Control"
        - $ref: "#/components/parameters/content-Security-Policy"
        - $ref: "#/components/parameters/content-Type"
        - $ref: "#/components/parameters/strict-Transport-Security"
        - $ref: "#/components/parameters/x-Content-Type-Options"
        - $ref: "#/components/parameters/x-Frame-Options"
        - $ref: "#/components/parameters/page"
        - $ref: "#/components/parameters/pageSize"
      responses:
        '200':
          description: Dados dos produtos de Business
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResponseBusinessList'
        '204':
          $ref: '#/components/responses/NoContent'
        '400':
          $ref: '#/components/responses/BadRequest'
        '401':
          $ref: '#/components/responses/Unauthorized'
        '403':
          $ref: '#/components/responses/Forbidden'
        '404':
          $ref: '#/components/responses/NotFound'
        '405':
          $ref: '#/components/responses/MethodNotAllowed'
        '406':
          $ref: '#/components/responses/NotAcceptable'
        '422':
          $ref: '#/components/responses/UnprocessableEntity'
        '429':
          $ref: '#/components/responses/TooManyRequests'
        '500':
          $ref: '#/components/responses/InternalServerError'
        default:
          description: Dados dos produtos de API de informações de dados do produto Empresarial. Os recursos que podem ser consumidos pelos participantes conforme a regra 3.1.2 do manual de escopo de dados.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResponseBusinessList'

components:
  schemas:
    ResponseBusinessList:
      type: object
      required:
        - data
        - links
        - meta
      properties:
        data:
          type: object
          required:
            - brand
          properties:
            brand:
              $ref: '#/components/schemas/BusinessBrand'
        links:
          $ref: '#/components/schemas/Links'
        meta:
          $ref: '#/components/schemas/Meta'
    BusinessBrand:
      type: object
      description: Organizacao controladora do grupo.
      required:
        - name
        - companies
      properties:
        name:
          type: string
          description: Nome da Marca reportada pelo participante do Open Insurance. O conceito a que se refere a 'marca' é em essência uma promessa da empresa em fornecer uma série específica de atributos, benefícios e serviços uniformes aos clientes.
          maxLength: 80
          example: ACME Group Seguros
        companies:
          $ref: '#/components/schemas/BusinessCompany'
    BusinessCompany:
      type: array
      items:
        description: Informações referente a sociedade a qual a marca pertence.
        required:
          - name
          - cnpjNumber
          - products
        properties:
          name:
            type: string
            description: Nome da sociedade pertencente à marca.
            maxLength: 80
            example: ACME Seguros
          cnpjNumber:
            type: string
            description: CNPJ da sociedade pertencente à marca.
            maxLength: 14
            example: "12345678901234"
          products:
            $ref: '#/components/schemas/BusinessProduct'
    BusinessProduct:
      type: array
      description: Lista de produtos de uma empresa.
      items:
        type: object
        required:
          - name
          - code
          - coverages
          - assistanceServices
          - microInsurance
          - traits
          - validity
          - premiumPayment
          - minimumRequirements
          - termsAndConditions
        properties:
          name:
            type: string
            description: Nome comercial do produto, pelo qual é identificado nos canais de distribuição e atendimento da sociedade.
            maxLength: 80
            example: Produto de Seguro
          code:
            type: string
            description: Código único a ser definido pela sociedade.
            maxLength: 100
            example: "01234589-0"

          coverages:
            type: array
            items:
              type: object
              required:
                - coverage
                - coverageDescription
                - coverageAttributes
                - allowApartPurchase
              properties:
                coverage:
                  type: string
                  description: Listagem de coberturas incluídas no produto que deve observar a relação discriminada de coberturas, conforme Tabela II.7 do Anexo II."
                  example: INCENDIO_QUEDA_DE_RAIO_E_EXPLOSAO
                  enum: [
                    INCENDIO_QUEDA_DE_RAIO_E_EXPLOSAO,
                    DANOS_ELETRICOS,
                    VENDAVAL_ATE_FUMACA,
                    DESMORONAMENTO,
                    ALAGAMENTO_E_INUNDACAO,
                    TUMULTOS_GREVES_LOCKOUT_E_ATOS_DOLOSOS,
                    ROUBO_E_FURTO_QUALIFICADO,
                    VALORES,
                    QUEBRA_DE_VIDROS_ESPELHOS_MARMORES_E_GRANITOS,
                    ANUNCIOS_LUMINOSOS,
                    FIDELIDADE_DE_EMPREGADOS,
                    RECOMPOSICAO_DE_REGISTROS_E_DOCUMENTOS,
                    DETERIORACAO_DE_MERCADORIAS_EM_AMBIENTES_FRIGORIFICADOS,
                    DERRAME,
                    VAZAMENTO,
                    EQUIPAMENTOS,
                    QUEBRA_DE_MAQUINAS,
                    RESPONSABILIDADE_CIVIL,
                    DESPESAS_EXTRAORDINARIAS,
                    LUCROS_CESSANTES_DESPESAS_FIXAS_LUCRO_LIQUIDO_LUCRO_BRUTO,
                    PERDA_OU_PAGAMENTO_DE_ALUGUEL,
                    PEQUENAS_OBRAS_DE_ENGENHARIA,
                    OUTRAS]
                coverageDescription:
                  type: string
                  maxLength: 3000
                  description: Campo aberto para detalhamento de cada uma das coberturas possíveis dos produtos
                  example: descrição cobertura
                coverageAttributes:
                  $ref: '#/components/schemas/BusinessCoverageAttributes'
                allowApartPurchase:
                  type: boolean
                  description: Indicação se a cobertura permite contratação separada (por cobertura selecionada).
                  example: true

          assistanceServices:
            $ref: '#/components/schemas/BusinessAssistanceServices'
          microInsurance:
            type: boolean
            description: Indicação se o produto é classificado como microsseguro.
            example: true
          traits:
            type: boolean
            description: Indicação se o produto é classificado como destinado para cobertura de grandes riscos, sendo tal classificação de acordo com regulamentação específica
            example: true
          validity:
            $ref: '#/components/schemas/BusinessValidity'
          premiumPayment:
            $ref: '#/components/schemas/BusinessPremiumPayment'
          termsAndConditions:
            $ref: '#/components/schemas/BusinessTerms'
          minimumRequirements:
            $ref: '#/components/schemas/BusinessMinimumRequirements'

    BusinessAssistanceServices:
      type: array
      description: Agrupamento dos serviços de assistências disponíveis vinculado ao produto.
      items:
        type: object
        required:
          - assistanceServices
        properties:
          assistanceServices:
            type: boolean
            description: O produto possui assistências?
            example: true
          assistanceServicesPackage:
            type: array
            items:
              type: string
              description: Para efeitos de comparabilidade considerar agrupamentos de serviços em 4 categorias, conforme os domínios
              example: ATE_10_SERVICOS
              enum: [ATE_10_SERVICOS, ATE_20_SERVICOS , ACIMA_20_SERVICOS, CUSTOMIZAVEL]
          complementaryAssistanceServicesDetail:
            type: string
            description: Campo livre para descrição dos serviços ofertados por cada sociedade participante, contendo minimamente cada um dos serviços assistenciais complementares oferecidos e se o pacote se trata de uma cobertura de assistência securitária ou se serviços de assistência
            maxLength: 1000
            example: reboque pane seca
          chargeTypeSignaling:
            type: string
            description: Indicação se o pacote de Assistência é gratuita ou contratada/paga.
            example: GRATUITO
            enum: [GRATUITO, PAGO]

    BusinessValidity:
      type: array
      items:
        type: object
        required:
          - term
        properties:
          term:
            type: array
            items:
              type: string
              example: ANUAL
              enum: [ANUAL , ANUAL_INTERMITENTE , PLURIANUAL , PLURIANUAL_INTERMITENTE , MENSAL, MENSAL_INTERMITENTE , DIARIO , DIARIO_INTERMITENTE, OUTROS]
          termOthers:
            type: string
            description: Campo livre para descrição por cada participante ao selecionar o domínio “Outros” no campo Prazo (acima).
            maxLength: 100

    BusinessPremiumPayment:
      type: array
      items:
        type: object
        required:
          - paymentMethod
          - paymentType
        properties:
          paymentMethod:
            type: string
            description: Metodo de pagamento
            enum: [CARTAO_DE_CREDITO, CARTAO_DE_DEBITO, DEBITO_EM_CONTA_CORRENTE, DEBITO_EM_CONTA_POUPANCA, BOLETO_BANCARIO, PIX, CONSIGNACAO_EM_FOLHA_DE_PAGAMENTO, PONTOS_DE_PROGRAMA_DE_BENEFICIO, OUTROS]
          paymentDetail:
            type: string
            maxLength: 100
            description: Campo livre para descrição por cada participante ao selecionar o domínio “Outros” no campo Meio de pagamento (acima)
          paymentType:
            type: string
            description: tipo de pagamento
            example: A_VISTA
            enum: [A_VISTA, PARCELADO]
          premiumRates:
            description: Distribuição de frequência relativa aos valores referentes às taxas cobradas, nos termos do Anexo III"
            type: string
            maxLength: 1024

    BusinessTerms:
      type: object
      description: Informações dos termos e condições conforme número do processo SUSEP.
      required:
        - definition
      properties:
        susepProcessNumber:
          type: string
          description: Número do processo SUSEP.
          maxLength: 20
          example: 15414.622222/2222-22
        definition:
          type: string
          description: Campo aberto (possibilidade de incluir uma url).
          maxLength: 1024
          example: https://www.seguradora.com.br/produto/tradicional/pdf/condicoes_gerais.pdf


    BusinessMinimumRequirements:
      type: object
      description: Requisitos mínimos.
      required:
        - contractType
        - minimumRequirementDetails
        - targetAudiences
      properties:
        contractType:
          type: array
          items:
            type: string
            example: COLETIVO
            enum: [COLETIVO, INDIVIDUAL]
        minimumRequirementDetails:
          type: string
          maxLength: 1024
          description: Campo aberto contendo todos os requisitos mínimos para contratação (possibilidade de incluir URL).
        targetAudiences:
          description: Público Alvo
          type: array
          items:
            type: string
            example: PESSOA_NATURAL
            enum: [PESSOA_NATURAL, PESSOA_JURIDICA]

    BusinessCoverageAttributes:
      type: object
      description: Informações de cobertura do Seguro Residencial.
      required:
        - maxLMI
        - insuredParticipation
      properties:
        maxLMI:
          $ref: '#/components/schemas/BusinessLimit'
        insuredParticipation:
          type: array
          description: Lista com indicativo do tipo de participação do segurado para cada cobertura
          items:
            type: string
            example: POS
            enum: [POS, FRANQUIA, NAO_SE_APLICA, OUTROS]
        insuredParticipationDescription:
          type: string
          maxLength: 1024
          description: Lista com descrição referente ao campo “Participação do Segurado” para cada cobertura.

    BusinessLimit:
      type: object
      description: Lista com valor de LMI aceito pela sociedade para cada cobertura.
      required:
        - type
        - amount
      properties:
        type:
          type: string
          enum: [FINANCEIRO, PERCENTUAL]
        amount:
          $ref: '#/components/schemas/BusinessCoverageAttributesDetails'
        index:
          type: string
          description: Indexador. Condicional, vinculado ao preenchimento do campo Tipo com Percentual
          enum: [LMG, FINANCEIRO_COBERTURA, OUTRO]
        maxIndexAmount:
          $ref: '#/components/schemas/BusinessCoverageAttributesDetails'

    BusinessCoverageAttributesDetails:
      type: object
      required:
        - amount
        - unit
      properties:
        amount:
          type: number
        unit:
          $ref: '#/components/schemas/BusinessCoverageAttributesDetailsUnit'

    BusinessCoverageAttributesDetailsUnit:
      type: object
      required:
        - code
        - description
      properties:
        code:
          type: string
          maxLength: 2
          example: R$
        description:
          type: string
          maxLength: 5
          example: REAL

    Links:
      type: object
      properties:
        self:
          type: string
          description: URL da página atualmente requisitada
          pattern: ^(https:\/\/)(.*?)(\/open-insurance\/products-services\/v\d+)(\/business.*)?$
          example: 'https://api.organizacao.com.br/open-insurance/products-services/v1/business'
        first:
          type: string
          description: URL da primeira página de registros
          pattern: ^(https:\/\/)(.*?)(\/open-insurance\/products-services\/v\d+)(\/business.*)?$
          example: 'https://api.organizacao.com.br/open-insurance/products-services/v1/business'
        prev:
          type: string
          description: URL da página anterior de registros
          pattern: ^(https:\/\/)(.*?)(\/open-insurance\/products-services\/v\d+)(\/business.*)?$
          example: 'https://api.organizacao.com.br/open-insurance/products-services/v1/business'
        next:
          type: string
          description: URL da próxima página de registros
          pattern: ^(https:\/\/)(.*?)(\/open-insurance\/products-services\/v\d+)(\/business.*)?$
          example: 'https://api.organizacao.com.br/open-insurance/products-services/v1/business'
        last:
          type: string
          description: URL da última página de registros
          pattern: ^(https:\/\/)(.*?)(\/open-insurance\/products-services\/v\d+)(\/business.*)?$
          example: 'https://api.organizacao.com.br/open-insurance/products-services/v1/business'

    Meta:
      type: object
      properties:
        totalRecords:
          type: integer
          description: Total de registros encontrados
          example: 10
        totalPages:
          type: integer
          description: Total de páginas para os registros encontrados
          example: 1
      required:
        - totalRecords
        - totalPages

    ResponseError:
      type: object
      required:
        - errors
      properties:
        errors:
          type: array
          minItems: 1
          maxItems: 13
          items:
            type: object
            required:
              - code
              - title
              - detail
              - requestDateTime
            properties:
              code:
                description: Código de erro específico do endpoint
                type: string
                pattern: '[\w\W\s]*'
                maxLength: 255
              title:
                description: Título legível por humanos deste erro específico
                type: string
                maxLength: 255
              detail:
                description: Descrição legível por humanos deste erro específico
                type: string
                maxLength: 2048
              requestDateTime:
                description: 'Data e hora da consulta, conforme especificação RFC-3339, formato UTC.'
                type: string
                maxLength: 2048
                format: date-time
                example: '2021-08-20T08:30:00Z'
            additionalProperties: false
        meta:
          $ref: '#/components/schemas/Meta'
      additionalProperties: false

  parameters:
    page:
      name: page
      in: query
      description: Número da página que está sendo requisitada (o valor da primeira página é 1).
      schema:
        type: integer
        default: 1
        minimum: 1
    pageSize:
      name: page-size
      in: query
      description: Quantidade total de registros por páginas.
      schema:
        type: integer
        default: 10
        minimum: 1
    cache-Control:
      name: cache-control
      in: header
      description: Controle de cache para evitar que informações confidenciais sejam armazenadas em cache.
      required: true
      schema:
        type: string
        pattern: '[\w\W\s]*'
    content-Security-Policy:
      name: Content-Security-Policy
      in: header
      description: Campo para proteção contra ataques clickjack do estilo - drag and drop.
      schema:
        type: string
        pattern: '[\w\W\s]*'
    content-Type:
      name: content-Type
      in: header
      description: Especificar o tipo de conteúdo da resposta.
      schema:
        type: string
        pattern: '[\w\W\s]*'
    strict-Transport-Security:
      name: Strict-Transport-Security
      in: header
      description: Campo para exigir conexões por HTTPS e proteger contra certificados falsificados.
      schema:
        type: string
        pattern:  '[\w\W\s]*'
    x-Content-Type-Options:
      name: X-Content-Type-Options
      in: header
      description: Campo para evitar que navegadores executem a detecção de MIME e interpretem respostas como HTML de forma inadequada.
      schema:
        type: string
        pattern: '[\w\W\s]*'
    x-Frame-Options:
      name: X-Frame-Options
      in: header
      description: Campo indica se o navegador deve ou não renderizar um frame.
      schema:
        type: string
        pattern: '[\w\W\s]*'

  responses:
    UnprocessableEntity:
      description: 'O servidor entende o tipo de conteúdo da entidade da requisição, e a sintaxe da requisição esta correta, mas não foi possível processar as instruções presente.'
      content:
        application/json; charset=utf-8:
          schema:
            $ref: '#/components/schemas/ResponseError'
    NoContent:
      description: 'O recurso solicitado não existe ou não foi localizado.'
      content:
        application/json; charset=utf-8:
          schema:
            $ref: '#/components/schemas/ResponseError'
    BadRequest:
      description: 'A requisição foi malformada, omitindo atributos obrigatórios, seja no payload ou através de atributos na URL.'
      content:
        application/json; charset=utf-8:
          schema:
            $ref: '#/components/schemas/ResponseError'
    Forbidden:
      description: O token tem escopo incorreto ou uma política de segurança foi violada
      content:
        application/json; charset=utf-8:
          schema:
            $ref: '#/components/schemas/ResponseError'
    InternalServerError:
      description: Ocorreu um erro no gateway da API ou no microsserviço
      content:
        application/json; charset=utf-8:
          schema:
            $ref: '#/components/schemas/ResponseError'
    MethodNotAllowed:
      description: O consumidor tentou acessar o recurso com um método não suportado
      content:
        application/json; charset=utf-8:
          schema:
            $ref: '#/components/schemas/ResponseError'
    NotAcceptable:
      description: A solicitação continha um cabeçalho Accept diferente dos tipos de mídia permitidos ou um conjunto de caracteres diferente de UTF-8
      content:
        application/json; charset=utf-8:
          schema:
            $ref: '#/components/schemas/ResponseError'
    NotFound:
      description: O recurso solicitado não existe ou não foi implementado
      content:
        application/json; charset=utf-8:
          schema:
            $ref: '#/components/schemas/ResponseError'
    TooManyRequests:
      description: 'A operação foi recusada, pois muitas solicitações foram feitas dentro de um determinado período ou o limite global de requisições concorrentes foi atingido'
      content:
        application/json; charset=utf-8:
          schema:
            $ref: '#/components/schemas/ResponseError'
    Unauthorized:
      description: Cabeçalho de autenticação ausente/inválido ou token inválido
      content:
        application/json; charset=utf-8:
          schema:
            $ref: '#/components/schemas/ResponseError'